<link rel="import" href="../../polymer/polymer-element.html">
<link rel="import" href="../../iron-a11y-keys/iron-a11y-keys.html">
<link rel="import" href="../../app-route/app-location.html">

<link rel="import" href="../collectar-service/collectar-service.html">
<link rel="import" href="../collectar-icons/collectar-icons.html">

<dom-module id="collectar-text-search">
  <template>
    <style>
      :host {
        display: block;
        --default-primary-color: #ec8930;
        --pink-theme-color: #b51b29;
        max-width: 550px;
        position: relative;
        @apply --collectar-text-search;
      }
      .search-field {
        display: flex;
      }
      .search-field paper-button {
        font-size: 0.8rem;
        padding: 5px 10px 5px 5px;
        margin: 0;
        border-radius: 0;
        color: var(--default-primary-color);
      }
      .search-field input {
        flex: 1;
        font-size: 0.8rem;
        height: 38px;
        border: none;
        background: #f2f2f2;
        padding-left: 10px;
        width: 150px;
      }
      .search-field paper-icon-button.search {
        position: absolute;
        right: 5px;
        opacity: 0.4;
      }
      .search-field input:focus {
        outline: none;
        padding-left: 10px;
      }
      .search-field input:focus::placeholder {
        opacity: .8;
      }
      .search-field input::placeholder {
        color: black;
        opacity: .4;
      }
      .search-field input:focus + paper-icon-button.search {
        opacity: 1;
        color: var(--default-primary-color);
      }
      .taxonomies {
        max-width: 60%;
        background: #f2f2f2;
        white-space: nowrap;
        overflow: auto;
      }
      .taxonomies span {
        font-size: 0.8rem;
        display: inline-block;
        padding: 5px;
        background: white;
        margin: 5px 2px;
      }
      .taxonomies span.highlight {
        background: var(--pink-theme-color);
          color: white;
      }
    </style>
    <app-location
      route="{{route}}"
      url-space-regex="^[[rootPath]]">
    </app-location>
    <collectar-service id="ajax" api="{{server}}" loading="{{loading}}"
      service="{{service}}" result="{{result}}" params="{{params}}"
      method="{{method}}" body="{{body}}" error="{{error}}">
    </collectar-service>
    <div class="search-field">
      <div class="taxonomies">
        <dom-repeat items="{{taxonomies}}">
          <template>
            <span class$="{{isHighlighted(item, removeCandidate)}}">
              {{item.name}}
            </span>
          </template>
        </dom-repeat>
      </div>
      <input id="input" placeholder="Buscar..." value="{{search::input}}">
      <paper-icon-button class="search" icon="app:search" on-tap="searchFor">
      </paper-icon-button>
      <iron-a11y-keys target="[[target]]" keys="backspace"
                    on-keys-pressed="onBackspace"></iron-a11y-keys>
      <iron-a11y-keys target="[[target]]" keys="enter"
                    on-keys-pressed="searchFor"></iron-a11y-keys>
    </div>
  </template>

  <script>
    /**
     * `collectar-text-search`
     * Simple text bar to search items on collections
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class CollectarTextSearch extends Polymer.Element {
      static get is() { return 'collectar-text-search'; }
      static get properties() {
        return {
          search: {
            type: String,
            notify: true,
            observer: 'searchTaxonomy',
            value: ''
          },
          server: {
            type: String,
            value: ''
          },
          result: {
            type: Object,
            observer: 'handleResult'
          },
          filter: {
            type: Object,
            notify: true
          },
          projectId: {
            type: String
          },
          taxonomies: {
            type: Array,
            notify: true,
            value() { return []; }
          },
          service: {
            type: String
          },
          uniqueElements: Array,
          disableTaxonomies: Boolean,
          route: Object
        };
      }

      static get observers() {
        return ['setInputValue(route.__queryParams.*)'];
      }

      connectedCallback() {
        super.connectedCallback();
        this.target = this.$.input;
      }

      searchTaxonomy(search) {
        if(this.disableTaxonomies) return;
        this.removeCandidate = undefined;
        if(!search.includes(' ') || this.loading) return;
        if(!this.filterResult) {
          this.remoteFilter(search);
        } else {
          this.localFilter(search);
        }
      }

      remoteFilter(search) {
        this.service = `projects/${this.projectId}/taxonomies?search=${search}`;
        this.$.ajax.generateRequest();
      }

      localFilter(search) {
        if(!this.filterResult) return;
        const reg = new RegExp(search.trim(), 'i');
        const filter = this.filterResult.filter((tax) => reg.test(tax.name));
        if (filter.length) {
          this.filterResult = filter;
          this.bestMatch = filter[0];
        } else {
          if (this.bestMatch && !this.taxonomies.map(i => i._id).includes(this.bestMatch._id)) {
            this.push('taxonomies', this.bestMatch);
            this.search = this.search.replace(/.* /, '');
          }
          this.filterResult = this.bestMatch = undefined;
        }
      }

      handleResult(result) {
        if (!result) return;
        this.filterResult = result;
        this.localFilter(this.search);
      }

      searchFor(e) {
        let query = `?search=${this.search}&`;
        if(!this.disableTaxonomies) query += `taxonomies=${this.taxonomies.map(t=>t._id)}&`;
        this.dispatchEvent(new CustomEvent('search', { detail: {
          search: this.search,
          taxonomies: this.taxonomies,
          query
        }, bubbles: true, composed: true }));
        this.service = `projects/${this.projectId}/taxonomies`;
      }

      onBackspace(e) {
        if(this.search || !this.taxonomies.length) return;
        const lastIndex = this.taxonomies.length - 1;
        if (this.removeCandidate) {
          this.splice('taxonomies', lastIndex, 1);
          this.removeCandidate = undefined;
        } else {
          this.removeCandidate = this.taxonomies[lastIndex];
        }
      }

      isHighlighted(item, removeCandidate) {
        if(!removeCandidate) return '';
        if (item._id === removeCandidate._id) return 'highlight';
        return '';
      }

      setInputValue(params) {
        if(!params.base.search) return;
        this.$.input.value = params.base.search;
      }

    }

    window.customElements.define(CollectarTextSearch.is, CollectarTextSearch);
  </script>
</dom-module>
